with Interfaces; use Interfaces;

package body CORBA_Repository_Root_ValueBoxDef_Hash is

   P : constant array (0 .. 3) of Natural :=
     (2, 4, 6, 9);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (31, 34, 24, 42);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (39, 24, 13, 8);

   G : constant array (0 .. 42) of Unsigned_8 :=
     (0, 0, 12, 13, 16, 0, 9, 6, 0, 4, 0, 9, 0, 0, 0, 0, 15, 0, 0, 0, 0, 12,
      0, 0, 18, 0, 0, 0, 0, 10, 11, 20, 0, 1, 3, 7, 0, 17, 0, 2, 8, 0, 3);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 43;
         F2 := (F2 + Natural (T2 (K)) * J) mod 43;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 21;
   end Hash;

end CORBA_Repository_Root_ValueBoxDef_Hash;
